/*
 *  Soccer Client Program main
 *    Ogalets the fourth
 *      presented by Ogawara
 */
#include "oga4.h"

Socket init_connection(char* host, int port) ;
void   message_loop(FILE* fpin, FILE* fpout, Socket sock) ;
static int time_stamp=0;
int  s_flag=0,h_flag=0,b_flag=0,collision_flag=0,w_flag=0,predict_flag=0;
int  predict_dir;
double predict_dist;

extern Socket sock ;
extern double mx,my;
extern double bx,by,ob_dist;
extern int  player,mdir;
extern char side,cir_flag,lost_flag;
extern int  play_mode,time_counter;
extern int  mp_num,op_num;
extern char team_name[];
extern double flag_posi[10][2],goal_posi[2][2];
extern double off_posi[11][2];
extern double area_posi[11][2];

extern struct relative_address ball,flag[12],goal[2],line[4],mplayer[11],oplayer[11];

#define DETECT_ANGLE (20)

void pass(double *address,double *address2){
    double dist,ox=address[0],oy=address[1];
    int  i,dir2,dir,odir,pow=0,k_flag=0;

    if (address2==NULL)
	address2=address;
    dist=get_dist(ox,oy,mx,my);
    dir=get_theta(ox,oy);
    if ((my>33.0) || (my<-33.0)){ /* around side line */
	if (my>33.0){
	    if ((mdir>0) && (mdir<90))
		k_flag=-1;
	    else if ((mdir>90) && (mdir<180))
		k_flag=1;
	} else{
	    if ((mdir>180) && (mdir<270))
		k_flag=-1;
	    else if ((mdir>270) && (mdir<360))
		k_flag=1;
	}
    }
    if (dir>120) /* kick back */
	k_flag=1;
    else if (dir<-120)
	k_flag=-1;
    if (k_flag!=0){
	kick(8,105*k_flag);
	usleep(20000);
	turn(90*k_flag);	    
	dir-=70*k_flag;
	usleep(210000);
    }
    if ((address[0]==goal_posi[1][0]) && (address[1]==goal_posi[1][1])) /* shoot */
	dist+=30.0;
    else if (k_flag==0){ /* enemy detection */
	dir2=get_theta(address2[0],address2[1]);
	if (dir==dir2)
	    k_flag=1;
	else if ((dir2<120) && (dir2>-120)){ /* check the other pass */
	    for (i=0;i<op_num;i++){
		if (oplayer[i].dist<20.0){
		    odir=oplayer[i].dir-dir2;
		    if ((odir>-DETECT_ANGLE) && (odir<DETECT_ANGLE))
			k_flag=1;
		}	
	    }
	} else
	    k_flag=1;
	for (i=0;i<op_num;i++){ /* check original pass */
	    if (oplayer[i].dist<20.0){
		odir=oplayer[i].dir-dir;
		if ((odir>-DETECT_ANGLE) && (odir<DETECT_ANGLE)){
		    if (!k_flag){
			dir=dir2;
		    } else{
			if (odir>0)
			    odir=DETECT_ANGLE-odir;
			else
			    odir=-DETECT_ANGLE-odir;
			dir-=odir;
		    }
		}
	    }
	}
    }
    kick((int)(dist*2.0)+20,dir);
    w_flag=0;
}

void search_ball(void){
    int  dir;

    dir=ball.dir;
    turn(dir);
    ob_dist=ball.dist;
    if ((ball.count==time_counter) && (b_flag))
	w_flag=1;
}

/* get relative angle */
int  get_theta(double ox,double oy){
    int  odir;
	
    odir=get_angle(ox-mx,oy-my);
    odir-=mdir;
    if (odir<-180)
	odir+=360;
    else if (odir>180)
	odir-=360;
    return odir;
}

#define DASH_RATIO (1.7)

/* go to relative position indicated by dist & odir */
void go(double dist,int odir){
    int  pow,i,o_flag=0,t_flag=0,max_loop=5;
    static double tx=0.0,ty=0.0;
    static int f_count=0;

    if (get_dist(mx,my,tx,ty)<0.5){
	if (++f_count>6){
	    i=random_num(2)*2-1;
	    turn(90*i);
	    usleep(110000);
	    dash(50);
	    usleep(40000);
	    turn(-90*i);
	    f_count=0;
	    return;
	}
    } else
	f_count=0;
    if (odir!=0){
	turn(odir);
	if ((odir>80) || (odir<-80)){
	    turn(odir);
	    return;
	} else{
	    turn(odir);
	    usleep(110000);
	}
	o_flag=1;
    } else if (collision_flag!=0){
	turn(80*collision_flag);
	usleep(110000);
	t_flag=1;
    }
/*    if ((!t_flag) && (!o_flag))
	max_loop+=2;*/
    for (i=0;i<4;i++){
	if (dist>DASH_RATIO)
	    pow=50;
	else
	    pow=(int)(dist*50.0/DASH_RATIO);
	dash(pow);
	if (pow!=50)
	    break;
	dist-=DASH_RATIO;
	usleep(30000);
    }
    if ((!o_flag) && (collision_flag!=0)){
	usleep(30000);
	turn(-80*collision_flag);
    }
    tx=mx; ty=my;
}

/* go to absolute position (ox,oy) */
void go_abs(double ox,double oy){
    double dist;
    int  odir;
	
    dist=get_dist(mx,my,ox,oy);
    odir=get_theta(ox,oy);
    go(dist,odir);
}

#define PREDICT_RATIO (1.5)
#define PREDICT_ANGLE (1.2)

/* go to ball using prediction */
void go_predict(void){
    double d1=ob_dist,d2=ball.dist,d3,d4;
    double theta=(double)(ball.dir),gamma;
    double theta2=theta*PI/180.0;

    w_flag=0;
    if (theta!=0.0){
	gamma=atan((d1*cos(theta2)-d2)/d1/sin(theta2));
	d3=d2*cos(gamma);
	d4=d2*sin(gamma);
	if (d4<0.0)
	    d4=-d4;
	if (d3>DASH_RATIO)
	    predict_flag = 1 ;
	if ((gamma*theta2>0.0) && (d4>10.0) && (d1>d2)){
	    go(d3,ball.dir+(int)(gamma*180.0/PI));
	    if (d3 > DASH_RATIO){
/*		predict_flag = 1 ;*/
		predict_dist = d3-DASH_RATIO;
		predict_dir = -ball.dir-(int)(gamma*180.0/PI);
	    }/* else{
		usleep(40000);
		turn(predict_dir);
	    }*/
	} else
	    go(ball.dist,ball.dir);
    } else
	go(ball.dist,ball.dir);
}

#define ERROR_RATIO (1.8)

int  think(void){
    static int rotate_flag=0;
    int  odir,i;
    char str[50];
    double dx,dy,dist;

    if (s_flag!=1) return 0;
    if (get_my_posi()==-1){
	turn(180); /* when lost */
	return 1;	
    }
    if (b_flag){ /* saw the ball */
	odir=mdir+ball.dir;
	bx=mx+ball.dist*cos((double)odir/180.0*PI);
	by=my+ball.dist*sin((double)odir/180.0*PI);
	sprintf(str,"(say %s %d %3.1lf %3.1lf)\n",team_name,time_stamp+1,bx,by);
	send_message(str,sock); /* inform the ball position */
	usleep(15000);
	rotate_flag=0;
    } else if (h_flag){
	ball.dist=get_dist(mx,my,bx,by);
	if (ball.dist>ERROR_RATIO){
	    ball.dir=get_theta(bx,by);
	    ball.count=time_counter;
	    h_flag=2;
	    rotate_flag=0;	    
	}
    }

    if (predict_flag) {
	go(predict_dist,0) ;
	usleep(40000);
	turn(predict_dir);
	predict_flag--;
    } else{
	if (cir_flag){ /* go to my position */
	    if ((ball.count==time_counter) && (ball.dist<15.0)){
		if (w_flag)
		    go_predict();
		else{
		    dist=ball.dist;
		    if (b_flag)
			if (ball.vdir==0)
			    dist+=10.0;
			else if ((ball.vdir==-180) && (dist>15.0))
			    dist-=15.0;
		    go(dist,ball.dir);
		}
		cir_flag=0;
	    } else if (get_dist(off_posi[player][0],off_posi[player][1],mx,my)>3.0)
		go_abs(off_posi[player][0],off_posi[player][1]);
	    else{
		cir_flag=0;
		search_ball();
	    }
	} else if (ball.count!=time_counter){ /* I can't see the ball */
	    if (rotate_flag==0){
		turn(-45);
		rotate_flag=1;
	    } else if (rotate_flag==1){
		turn(90);
		rotate_flag=2;
	    } else{
		turn(45);
	    }
	} else if ((ball.dist>20.0)
		   && ((bx<off_posi[player][0]-area_posi[player][0])
		       || (bx>off_posi[player][0]+area_posi[player][0])
		       || (by<off_posi[player][1]-area_posi[player][1])
		       || (by>off_posi[player][1]+area_posi[player][1]))){
	    if (get_dist(off_posi[player][0],off_posi[player][1],mx,my)>3.0){
		go_abs(off_posi[player][0],off_posi[player][1]);		
		cir_flag=1;
	    } else{
		search_ball();		
	    }
	}else if (ball.dist>15.0){
	    if (w_flag){
		cir_flag=0;
		go_predict();
	    } else if (get_dist(off_posi[player][0],off_posi[player][1],mx,my)>35.0){
		go_abs(off_posi[player][0],off_posi[player][1]);		
		cir_flag=1;
	    } else
		search_ball();
	}else if (ball.dist>1.8){
	    if (w_flag)
		go_predict();
	    else if (get_dist(off_posi[player][0],off_posi[player][1],mx,my)>35.0){
		go_abs(off_posi[player][0],off_posi[player][1]);		
		cir_flag=1;
	    } else{
		dist=ball.dist;
		if (b_flag)
		    if (ball.vdir==0)
			dist+=10.0;
		    else if ((ball.vdir==-180) && (dist>10.0))
			dist-=10.0;
		if ((player==0) && (!b_flag))
		    search_ball();
		else
		    go(dist,ball.dir);
	    }
	} else{
	    if ((my>20.0) || (my<-20.0)){
		if (my>20.0) /* in top area */
		    i=0;
		else /* in bottom area */
		    i=1;
		
		if (mx<-30.0)
		    pass(off_posi[3+i],NULL);
		else if (mx>41.0)
		    pass(off_posi[2-i],NULL);
		else if (mx>0.0)
		    pass(goal_posi[1],NULL);		
		else
		    if (random_num(2)==0)
			pass(off_posi[3+i],off_posi[4-i]);
		    else
			pass(off_posi[4-i],off_posi[3+i]);
	    } else{
		if (mx<-20.0)
		    pass(off_posi[random_num(3)+3],off_posi[random_num(3)+3]);
		else if (mx<10.0) 
		    pass(off_posi[random_num(4)+1],off_posi[random_num(4)+1]);
		else if (mx<25.0){
		    if (my>0.0)
			pass(off_posi[2],off_posi[1]);
		    else
			pass(off_posi[1],off_posi[2]);
		} else if (mx<45.0)
		    pass(goal_posi[1],NULL);
		else if ((my>-10.0) && (my<10.0)){
		    pass(goal_posi[1],NULL);
		} else if (my>10.0)
		    pass(off_posi[2],off_posi[1]);
		else
		    pass(off_posi[1],off_posi[2]);
	    }
	}
    }
    return 1;
}	

		
void see(char *buf){
    int  i;
    char *b_ptr=buf,name[100],*n_ptr;
    double odir;
    struct relative_address dummy,*dum_p;

    mp_num=0;
    op_num=0;
    if (++time_counter==MAX_TIME_COUNTER)
	time_counter=0;
    do ++b_ptr;
    while((*b_ptr!='(') && (*b_ptr!=')'));
    if (*b_ptr==')')
	return;
    b_ptr+=2;
    while(1){
	switch(*b_ptr){
	  case 'l': /* line */
	    b_ptr+=5;
	    switch(*b_ptr){
	      case 'l': /* left end */
		if (side=='l') i=0;
		else i=1;
		break;
	      case 'r': /* right end */
		if (side=='l') i=1;
		else i=0;
		break;
	      case 't': /* top end */
		i=2; break;
	      case 'b': /* bottom end */
		i=3; break;
	    }
	    b_ptr+=3;
	    b_ptr=get_para(&line[i],b_ptr);
	    
	    if (line[i].dir>0)
		line[i].dir=90-line[i].dir;
	    else
		line[i].dir=-90-line[i].dir;
	    
	    break;

	  case 'p': /* player */
	    b_ptr+=6;
	    if (*(b_ptr++)==' '){
		n_ptr=name;
		while((*b_ptr!=')') && (*b_ptr!=' '))
		    *n_ptr++=*b_ptr++;
		*n_ptr=0;
		if (*b_ptr==' ')
		    while(*b_ptr!=')')
			b_ptr++;
		if (strcmp(name,team_name)==0)
		    dum_p=&mplayer[mp_num++];
		else
		    dum_p=&oplayer[op_num++];
		b_ptr=get_para(dum_p,b_ptr+2);
		if (dum_p->dist<2.0){
		    if ((dum_p->dir<60) && (dum_p->dir>0))
			collision_flag=-1;
		    else if ((dum_p->dir>-60) && (dum_p->dir<0))
			collision_flag=1;
		}
	    } else{
		b_ptr=get_para(&dummy,b_ptr+2);
	    }
	    break;

	  case 'g': /* goal */
	    b_ptr+=5;
	    if (*b_ptr==side)
		i=0;
	    else
		i=1;
	    b_ptr=get_para(&goal[i],b_ptr+3);		
	    break;

	  case 'b': /* ball */
	    b_ptr=get_para(&ball,b_ptr+6);
	    b_flag=1;
	    break;

	  case 'f': /* flag */
	    b_ptr+=5;
	    i=1;
	    while(1){
		switch(*b_ptr){
		  case 'p':
		    i+=3; break;
		  case 'l':
		    if (side=='l') i+=1;
		    else i+=6;
		    break;
		  case 'r':
		    if (side=='l') i+=6;
		    else i+=1;
		    break;
		  case 't':
		    break;
		  case 'b':
		    i+=1; break;
		  case 'c':
		    i-=1; break;
		}
		b_ptr+=2;
		if (*b_ptr==' ')
		    break;
	    }
	    b_ptr=get_para(&flag[i],b_ptr+1);
	    break;
	}
	if (*b_ptr==')')
	    break;
	else
	    b_ptr+=3;
    }
}
	
int hear(char *buf){
    int  t_code,t;
    char dir_str[50],mes[50];
    double x,y;
    
    sscanf(buf,"(hear %d %s %s)",&t,dir_str,mes);
    if (strcmp(mes,team_name)==0){
	sscanf(buf,"(hear %d %s %s %d %lf %lf)",&t,dir_str,mes,&t_code,&bx,&by);
	if (t_code>=time_stamp){
	    time_stamp=t_code;
	    if ((!b_flag) && (strcmp(dir_str,"self")!=0))
		h_flag=1;
	} /* else
	    printf("mimic message \n  %s!!\n",buf);*/
    } else{
	if (strcmp("self",dir_str)==0) return -1;
	if (strcmp("referee",dir_str)!=0) return -1;
	if (strncmp("kick_off_",mes,9)==0) return 1;
    }
    return -1;
}
	

void message_loop(FILE* fpin, FILE* fpout, Socket sock)
{
    fd_set	readfds ;
    int		in, max_fd, n ;
    char	buf[MAXMESG];
    char	end_mes[]="quit";

    in = fileno(fpin) ;
    while(1){
	FD_ZERO(&readfds) ;
	FD_SET(in, &readfds) ;
	FD_SET(sock.socketfd, &readfds) ;

	max_fd = ((in > sock.socketfd) ? in : sock.socketfd) + 1 ;
	if(select(max_fd, &readfds, 0, 0, 0) == -1){
	    perror("select") ;
	    break ;
	}

	if(FD_ISSET(in, &readfds)){
	    fgets(buf, MAXMESG, fpin) ;
	    	if (strncmp(end_mes,buf,4)==0) break;
	}

	if(FD_ISSET(sock.socketfd, &readfds)){
	    n = receive_message(buf, MAXMESG, &sock) ;
	    if(n == -1)
		break ;
	    else if(n > 0){
	    	if (buf[1]=='s'){
		    see(buf);
		    s_flag=1;		    
	    	} else
		    hear(buf);
		fflush(stdout) ;
	    }			
	}
	if (think()){
	    s_flag=0;
	    h_flag=0;
	    b_flag=0;
	    collision_flag=0;
	}
    }
}

/*
 * socket  close
 *
 *  :
 * sock : socket
 * 
 */


/* for test */
#ifdef TEST
void main(int argc, char **argv)
{
    char *server;
    int port=6000;


    if(argc == 3) {
	server = argv[1] ;
	port = atoi(argv[2]) ;
    } else if (argc == 2) {
	server = argv[1] ;
	port = 6000 ;
    } else {
	server = "localhost" ;
	port = 6000 ;
    }
    
    sock = init_connection(server,port) ;
    
    if(sock.socketfd == -1)
	exit(1) ;
    
    if (init_condition(team_name)!=-1)
	    message_loop(stdin, stdout, sock) ;

    close_connection(sock) ;
}
#endif /* TEST */

