/*
 *  Soccer Client Program basic routines
 *    Ogalets the fourth
 *      presented by Ogawara
 */
#include "oga4.h"

Socket init_connection(char* host, int port) ;
int    send_message(char* buf, Socket sock) ;
int    receive_message(char *buf, int size, Socket *sock) ;
void   close_connection(Socket sock) ;

Socket sock ;
double mx,my,vmx,vmy;
double bx,by,ob_dist=0;
int  player,mdir;
char side,cir_flag=0,lost_flag=0;
int  play_mode=0,time_counter=0;
int  mp_num,op_num; /* mp_num...number of my team in sight, op_num...that of opponent team */
char team_name[]="Ogalets";
double flag_posi[12][2]={{0.0,34.0},{0.0,-34.0}
			 ,{-52.5,34.0},{-52.5,-34.0},{-36.0,0.0},{-36.0,20.0},{-36.0,-20.0}
			 ,{ 52.5,34.0},{ 52.5,-34.0},{ 36.0,0.0},{ 36.0,20.0},{ 36.0,-20.0}};
double goal_posi[2][2]={{-52.5,0},{52.5,0}};
int  init_posi[11][10]={{-50,0},{-1,0},{-1,-3},{-1,30},{-1,-30},{-15,0},{-40,25},{-40,-25},{-30,0},
			{-35,15},{-35,-15}};
double off_posi[11][2]={{-50,0},{42,8},{40,-8},{25,30},{25,-30},{10,0},{-10,25},{-10,-25},{-20,0},
			    {-35,10},{-35,-10}};
double area_posi[11][2]={{20,15},{15,15},{20,15},{30,20},{30,20},{20,25},{20,15},{20,15},{20,25},
			     {20,25},{20,25}};

struct relative_address ball,flag[12],goal[2],line[4],mplayer[11],oplayer[11];

int  get_angle(double dx,double dy){
	double dist=sqrt(dx*dx+dy*dy);
	double a,b;
 	int dir;

	dx/=dist;
	dy/=dist;
	a=asin(dy);
	b=acos(dx);
	dir=(int)(b*180.0/PI);
	if (a<0)
		dir=360-dir;
	return dir;
}
	
int  get_my_posi(void){ /* get my position from the sight information */
    int  i,num=0,cond_flag=0,dir,tdir[2];
    double dist,px,py,lxy[2],txy[2],t2xy[2];

    if (lost_flag>0){
	if ((vmx>-52.0) && (vmx<52.0) && (vmy>-33.5) && (vmy<33.5))
	    lost_flag=0;
	else if (lost_flag++>3)
	    lost_flag=0;
    }
    for (i=0;i<4;i++){
	if (line[i].count==time_counter){
	    dist=line[i].dist*cos((double)line[i].dir*PI/180.0);
	    switch(i){
	      case 0: /* left end */
		lxy[0]=-52.5+dist;
		tdir[0]=line[i].dir+180;
		lxy[1]=-52.5-dist;
		tdir[1]=line[i].dir;
		cond_flag|=1;
		break;
	      case 1: /* right end */
		lxy[0]=52.5-dist;
		tdir[0]=line[i].dir;
		lxy[1]=52.5+dist;
		tdir[1]=line[i].dir+180;
		cond_flag|=1;
		break;
	      case 2: /* top end */
		lxy[0]=34.0-dist;
		tdir[0]=line[i].dir+90;
		lxy[1]=34.0+dist;
		tdir[1]=line[i].dir+270;
		cond_flag|=2;
		break;
	      case 3: /* bottom end */
		lxy[0]=-34.0+dist;
		tdir[0]=line[i].dir+270;
		lxy[1]=-34.0-dist;
		tdir[1]=line[i].dir+90;
		cond_flag|=2;
		break;
	    }
	}
    }
    if (cond_flag==0){
	lost_flag=1;
	return -1;
    }
    for (i=0;i<12;i++){
	if (flag[i].count==time_counter){
	    if ((num==0) || (dist<flag[i].dist)){
		dist=flag[i].dist;
		dir=flag[i].dir;
		px=flag_posi[i][0];
		py=flag_posi[i][1];
		num++;
	    }
	}
    }
    for (i=0;i<2;i++){
	if (goal[i].count==time_counter){
	    if ((num==0) || (dist<goal[i].dist)){
		dist=goal[i].dist;
		dir=goal[i].dir;
		px=goal_posi[i][0];
		py=goal_posi[i][1];
		num++;
	    }		
	}
    }
    if (num>0){
	for (i=0;i<2;i++)
	    if (cond_flag==1)
		txy[i]=px-dist*cos((double)(tdir[i]+dir)*PI/180.0);
	    else	
		txy[i]=py-dist*sin((double)(tdir[i]+dir)*PI/180.0);
	for (i=0;i<2;i++)
	    t2xy[i]=abs_d((lxy[i]-txy[i]));
	if (t2xy[0]>t2xy[1])
	    i=1;
	else
	    i=0;
	if (t2xy[1-i]-t2xy[i]<1.0)
	    if (lost_flag)
		i=1;
	    else
		i=0;
	if (cond_flag==1){
	    if ((lxy[i]<-57.5) || (lxy[i]>57.5))
		i=1-i;	    
	    mx=lxy[i];
	    my=py-dist*sin((double)(tdir[i]+dir)*PI/180.0);
	    mdir=tdir[i];
	} else{
	    if ((lxy[i]<-39.0) || (lxy[i]>39.0))
		i=1-i;	    	    
	    mx=px-dist*cos((double)(tdir[i]+dir)*PI/180.0);
	    my=lxy[i];
	    mdir=tdir[i];	    
	}
    } else{
	if (lost_flag)
	    i=1;
	else
	    i=0;
	if (cond_flag==1)
	    mx=lxy[i];
	else
	    my=lxy[i];
	mdir=tdir[i];
    }
/*    printf("my posi=(%lf,%lf) dir=%d\n",mx,my,mdir);*/
    vmx=mx; vmy=my;
    return 0;
}
				
void kick(int pow,int dir){
    char mes[50];
	
    if (pow<0)
	pow=0;
    else if (pow>100)
	pow=100;
    if (side=='l')
	dir=-dir;
    if (dir<-180)
	dir=-180;
    else if (dir>180)
	dir=180;
    sprintf(mes,"(kick %d %d)\n",pow,dir);
    send_message(mes,sock);
}
	
void dash(int pow){
    char mes[50];
    
    if (pow>100)
	pow=100;
    else if (pow<-30)
	pow=-30;
    sprintf(mes,"(dash %d)\n",pow);
    send_message(mes,sock);
    vmx+=(double)pow*1.7/50.0*cos((double)mdir*PI/180.0);
    vmy+=(double)pow*1.7/50.0*sin((double)mdir*PI/180.0);	
}
	
void turn(int angle){
    char mes[50];
	
    if (side=='l')
	angle=-angle;
    if (angle<-180)
	angle+=360;
    else if (angle>180)
	angle-=360;
    sprintf(mes,"(turn %d)\n",angle);
    send_message(mes,sock);
}
	
/*  buf...dist angle v_dist */
char *get_para(struct relative_address *st,char *buf){
	double dist=0;
	int  dir=0,m_flag=0;
	
	st->count=time_counter;
	st->vdir=-1;
	while(*buf!=' '){
	    if (*buf=='.'){
		buf++;
		dist+=(double)(*buf-'0')/10;
	    } else
		dist=dist*10+(double)(*buf-'0');
	    buf++;
	}
	st->dist=dist;

	buf++;
	while((*buf!=')') && (*buf!=' ')){
	    if (*buf=='-') m_flag=1;
	    else dir=dir*10+(int)(*buf-'0');	
	    buf++;
	}
	if (dir==180) /* ????? */
	    dir=0;
	if (m_flag) dir=-dir;
	if (side=='l')
	    dir=-dir;
	st->dir=dir;
	if (*buf==')')
	    return (buf+1);

	buf++;
	dir=0;
	m_flag=0;
	while(*buf!=')'){
	    if (*buf=='-') m_flag=1;
	    else dir=dir*10+(int)(*buf-'0');	
	    buf++;
	}
	if (m_flag) dir=-dir;
	if (side=='l')
	    dir=-dir;
	st->vdir=dir;

	return (buf+1);
}
	
int init_condition(char *name){	/* -1...error */
    char buf[MAXMESG],info[3][20];
    int  i,count,i_count;
    char init_mes1[30],mov_mes1[30];

    sprintf(init_mes1,"(init %s)\n",name);
    send_message(init_mes1,sock);
    while (receive_message(buf, MAXMESG, &sock)<=0) ;

    if (buf[1]=='e'){
	printf("initialize error\n");
	return -1;
    }
    
    count=6;
    for (i=0;i<3;i++){
	i_count=0;
	while ((buf[count]!=' ') && (buf[count]!=')'))
	    info[i][i_count++]=buf[count++];
	count++;
	info[i][i_count]=0;
    }
    if (strcmp("before_kick_off",info[2])!=0){
	printf("match is on play\n");
	return -1;
    }
    player=atoi((char *)info[1])-1;
    side=info[0][0];
    if (side=='l')
	init_posi[player][1]=-init_posi[player][1];
    mx=(double)init_posi[player][0];
    my=(double)init_posi[player][1];
    sprintf(mov_mes1,"(move %d %d)\n",init_posi[player][0],init_posi[player][1]);
    usleep(100000);
    send_message(mov_mes1,sock);
    usleep(100000);
    send_message("(change_view narrow high)\n",sock);
    bx=0; by=0;

    while(1){
	while (receive_message(buf, MAXMESG, &sock)<=0) ;
	if (buf[1]=='h'){
	    if (hear(buf)==1){
		return 0;
	    }
	}
    }
}

	
/*
 * UDP connection γ
 *
 *  :
 * host : host name ⤷ host  IP address
 * port : port ֹ
 * 
 *  :
 * error ȯ硢Socket.socketfd  -1 ֤
 * 
 */
 
Socket init_connection(char *host, int port)
{
    struct hostent 	*host_ent ;
    struct in_addr      *addr_ptr ;
    struct sockaddr_in	cli_addr ;
    int			sockfd, val ;
    Socket		sock ;

    sock.socketfd = -1 ;

    if((host_ent = (struct hostent *)gethostbyname(host)) == NULL) {
	/* Check if a numeric address */
	if(inet_addr(host) == -1){
	    return sock ;
	}
    }
    else{
	addr_ptr = (struct in_addr *) *host_ent->h_addr_list ;
	host = inet_ntoa(*addr_ptr) ;
    }


    /*
     *  Open UDP socket.
     */
    if( (sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0){
	return sock ;  	/* Can't open socket. */
    }

    val = fcntl(sockfd, F_GETFL, 0) ;
    val |= O_NONBLOCK ;
    fcntl(sockfd, F_SETFL, val) ;

    /*
     *  Bind any local address.
     */
    bzero((char *) &cli_addr, sizeof(cli_addr)) ;
    cli_addr.sin_family		= AF_INET ;
    cli_addr.sin_addr.s_addr	= htonl(INADDR_ANY) ;
    cli_addr.sin_port		= htons(0) ;


    if(bind(sockfd, (struct sockaddr *) &cli_addr,
	    sizeof(cli_addr)) < 0){
	return sock ;  /* Can't bind local address */
    }
    

    /*
     *  Fill in the structure with the address of the server.
     */
    sock.socketfd = sockfd ;

    bzero((char *) &sock.serv_addr, sizeof(sock.serv_addr)) ;
    sock.serv_addr.sin_family		= AF_INET ;
    sock.serv_addr.sin_addr.s_addr	= inet_addr(host) ;
    sock.serv_addr.sin_port		= htons(port) ;

    return sock ;
}


/*
 * socket  message 
 *
 *  :
 * buf  : message 
 * sock : socket
 * 
 *  :
 * Ф˼Ԥ硢-1 ֤
 * 
 */

int send_message(char *buf, Socket sock)
{
    int n ;

    n = strlen(buf) ;
/*    printf( "send %d : %s\n",
	ntohs(sock.serv_addr.sin_port),buf);*/
    if( sendto(sock.socketfd, buf, n, 0,
	        (struct sockaddr *)&sock.serv_addr, sizeof(sock.serv_addr))
	  != n )
	return (-1) ;
    else
	return 0 ;
}
	   
/*
 * socket  message μ
 *
 *  :
 * buf  : message  buffer
 * size : sizeof(buf)
 * sock : socket
 * 
 *  :
 * ˼Ԥ硢-1 ֤
 * Ƥ̵硢 0 ֤
 * Ƥ硢 1 ֤
 * 
 */

int receive_message(char *buf, int size, Socket *sock)
{
    int			n,servlen ;
    struct sockaddr_in	serv_addr ;
    
    servlen = sizeof(serv_addr) ;
    n = recvfrom(sock->socketfd, buf, size, 0,
			 (struct sockaddr *)&serv_addr, &servlen);

    if(n < 0)
	if( n == -1 && errno == EWOULDBLOCK){
	    buf[0] = '\0' ;
	    return 0 ;
	}
	else
	    return (-1) ;
    else{
/*	printf( "recv %d : ", ntohs(serv_addr.sin_port));*/
	sock->serv_addr.sin_port = serv_addr.sin_port ;
	buf[n] = '\0' ;

	if(n == 0)
	    return 0 ;
	else
	    return 1 ;
    }
}



/*
 * socket  close
 *
 *  :
 * sock : socket
 * 
 */

void close_connection(Socket sock)
{
    close(sock.socketfd) ;
}
